from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  pipefail = 3
  noexec = 4
  xtrace = 5
  verbose = 6
  noglob = 7
  noclobber = 8
  posix = 9
  vi = 10
  emacs = 11
  interactive = 12
  hashall = 13
  failglob = 14
  extglob = 15
  eval_unsafe_arith = 16
  parse_dynamic_arith = 17
  compat_array = 18
  verbose_errexit = 19
  allow_command_sub = 20
  dynamic_scope = 21
  nullglob = 22
  inherit_errexit = 23
  strict_argv = 24
  strict_arith = 25
  strict_array = 26
  strict_control_flow = 27
  strict_errexit = 28
  strict_nameref = 29
  strict_word_eval = 30
  strict_tilde = 31
  strict_glob = 32
  parse_at = 33
  parse_brace = 34
  parse_paren = 35
  parse_triple_quoted = 36
  parse_triple_dots = 37
  simple_word_eval = 38
  dashglob = 39
  expand_aliases = 40
  command_sub_errexit = 41
  process_sub_fail = 42
  parse_set = 43
  parse_equals = 44
  parse_at_all = 45
  parse_backslash = 46
  parse_backticks = 47
  parse_dollar = 48
  parse_ignored = 49
  parse_amp = 50
  simple_echo = 51
  simple_eval_builtin = 52
  simple_test_builtin = 53
  parse_tea = 54
  lastpipe = 55
  progcomp = 56
  histappend = 57
  hostcomplete = 58
  cmdhist = 59
  assoc_expand_once = 60
  autocd = 61
  cdable_vars = 62
  cdspell = 63
  checkhash = 64
  checkjobs = 65
  checkwinsize = 66
  complete_fullquote = 67
  direxpand = 68
  dirspell = 69
  dotglob = 70
  execfail = 71
  extdebug = 72
  extquote = 73
  force_fignore = 74
  globasciiranges = 75
  globstar = 76
  gnu_errfmt = 77
  histreedit = 78
  histverify = 79
  huponexit = 80
  interactive_comments = 81
  lithist = 82
  localvar_inherit = 83
  localvar_unset = 84
  login_shell = 85
  mailwarn = 86
  no_empty_cmd_completion = 87
  nocaseglob = 88
  nocasematch = 89
  progcomp_alias = 90
  promptvars = 91
  restricted_shell = 92
  shift_verbose = 93
  sourcepath = 94
  xpg_echo = 95
  ARRAY_SIZE = 96

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.pipefail',
  4: 'option.noexec',
  5: 'option.xtrace',
  6: 'option.verbose',
  7: 'option.noglob',
  8: 'option.noclobber',
  9: 'option.posix',
  10: 'option.vi',
  11: 'option.emacs',
  12: 'option.interactive',
  13: 'option.hashall',
  14: 'option.failglob',
  15: 'option.extglob',
  16: 'option.eval_unsafe_arith',
  17: 'option.parse_dynamic_arith',
  18: 'option.compat_array',
  19: 'option.verbose_errexit',
  20: 'option.allow_command_sub',
  21: 'option.dynamic_scope',
  22: 'option.nullglob',
  23: 'option.inherit_errexit',
  24: 'option.strict_argv',
  25: 'option.strict_arith',
  26: 'option.strict_array',
  27: 'option.strict_control_flow',
  28: 'option.strict_errexit',
  29: 'option.strict_nameref',
  30: 'option.strict_word_eval',
  31: 'option.strict_tilde',
  32: 'option.strict_glob',
  33: 'option.parse_at',
  34: 'option.parse_brace',
  35: 'option.parse_paren',
  36: 'option.parse_triple_quoted',
  37: 'option.parse_triple_dots',
  38: 'option.simple_word_eval',
  39: 'option.dashglob',
  40: 'option.expand_aliases',
  41: 'option.command_sub_errexit',
  42: 'option.process_sub_fail',
  43: 'option.parse_set',
  44: 'option.parse_equals',
  45: 'option.parse_at_all',
  46: 'option.parse_backslash',
  47: 'option.parse_backticks',
  48: 'option.parse_dollar',
  49: 'option.parse_ignored',
  50: 'option.parse_amp',
  51: 'option.simple_echo',
  52: 'option.simple_eval_builtin',
  53: 'option.simple_test_builtin',
  54: 'option.parse_tea',
  55: 'option.lastpipe',
  56: 'option.progcomp',
  57: 'option.histappend',
  58: 'option.hostcomplete',
  59: 'option.cmdhist',
  60: 'option.assoc_expand_once',
  61: 'option.autocd',
  62: 'option.cdable_vars',
  63: 'option.cdspell',
  64: 'option.checkhash',
  65: 'option.checkjobs',
  66: 'option.checkwinsize',
  67: 'option.complete_fullquote',
  68: 'option.direxpand',
  69: 'option.dirspell',
  70: 'option.dotglob',
  71: 'option.execfail',
  72: 'option.extdebug',
  73: 'option.extquote',
  74: 'option.force_fignore',
  75: 'option.globasciiranges',
  76: 'option.globstar',
  77: 'option.gnu_errfmt',
  78: 'option.histreedit',
  79: 'option.histverify',
  80: 'option.huponexit',
  81: 'option.interactive_comments',
  82: 'option.lithist',
  83: 'option.localvar_inherit',
  84: 'option.localvar_unset',
  85: 'option.login_shell',
  86: 'option.mailwarn',
  87: 'option.no_empty_cmd_completion',
  88: 'option.nocaseglob',
  89: 'option.nocasematch',
  90: 'option.progcomp_alias',
  91: 'option.promptvars',
  92: 'option.restricted_shell',
  93: 'option.shift_verbose',
  94: 'option.sourcepath',
  95: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  builtin = 10
  readonly = 11
  local = 12
  declare = 13
  typeset = 14
  export_ = 15
  test = 16
  bracket = 17
  true_ = 18
  false_ = 19
  read = 20
  echo = 21
  printf = 22
  mapfile = 23
  readarray = 24
  cd = 25
  pushd = 26
  popd = 27
  dirs = 28
  pwd = 29
  source = 30
  umask = 31
  wait = 32
  jobs = 33
  fg = 34
  bg = 35
  shopt = 36
  complete = 37
  compgen = 38
  compopt = 39
  compadjust = 40
  getopts = 41
  command = 42
  type = 43
  hash = 44
  help = 45
  history = 46
  alias = 47
  unalias = 48
  bind = 49
  push = 50
  write = 51
  json = 52
  pp = 53
  use = 54
  opts = 55
  fopen = 56
  run = 57
  fork = 58
  forkwait = 59
  cat = 60
  ARRAY_SIZE = 61

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.builtin',
  11: 'builtin.readonly',
  12: 'builtin.local',
  13: 'builtin.declare',
  14: 'builtin.typeset',
  15: 'builtin.export_',
  16: 'builtin.test',
  17: 'builtin.bracket',
  18: 'builtin.true_',
  19: 'builtin.false_',
  20: 'builtin.read',
  21: 'builtin.echo',
  22: 'builtin.printf',
  23: 'builtin.mapfile',
  24: 'builtin.readarray',
  25: 'builtin.cd',
  26: 'builtin.pushd',
  27: 'builtin.popd',
  28: 'builtin.dirs',
  29: 'builtin.pwd',
  30: 'builtin.source',
  31: 'builtin.umask',
  32: 'builtin.wait',
  33: 'builtin.jobs',
  34: 'builtin.fg',
  35: 'builtin.bg',
  36: 'builtin.shopt',
  37: 'builtin.complete',
  38: 'builtin.compgen',
  39: 'builtin.compopt',
  40: 'builtin.compadjust',
  41: 'builtin.getopts',
  42: 'builtin.command',
  43: 'builtin.type',
  44: 'builtin.hash',
  45: 'builtin.help',
  46: 'builtin.history',
  47: 'builtin.alias',
  48: 'builtin.unalias',
  49: 'builtin.bind',
  50: 'builtin.push',
  51: 'builtin.write',
  52: 'builtin.json',
  53: 'builtin.pp',
  54: 'builtin.use',
  55: 'builtin.opts',
  56: 'builtin.fopen',
  57: 'builtin.run',
  58: 'builtin.fork',
  59: 'builtin.forkwait',
  60: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

